'Leuchtturm 30 Tiny 45
' 3264 Byte
$Regfile="attiny45.dat"
$Crystal=8000000
$hwstack=36
'------------------------------------------------------------------------------
Dim Zeit as Word 'die verflossene Zeit in 1/1000 Sekunden
Dim N as Word    'wie Zeit jedoch zum ermiiteln der Schaltpunkte der PWM
Dim PWMZeit as Word ' die Zeit whrend einer PWM Leuchtdauer
Dim MaxZeit as Word ' die Gesamtdauer einer Ein- oder Ausschaltphase
Dim PWMEinheit as Word 'die Dauer fr einen der 100 Helligkeitswerte
Dim Zeitmessung_ein as Byte 'startet und stoppt die Zeitmessung u.PWM-Steuerung
Zeitmessung_ein=0
Dim LEDAn as Byte  '1 in der Einschaltphase, 0 in der Ausschaltphase

Dim Kurvenform as Byte, EKurvenform as ERAM Byte
'0 = 1 = An /Aus
'2 = Drehfeuer
'3 = Funkelfeuer

Dim Preload1 as Byte'Preloadwert fr Timer1

Dim T as String * 1 'Eingabe, ein Zeichen
Dim E as String * 8 'ganzer Eingabestring
Dim Wl as Byte'max. Eingabelnge
Dim A as Byte 'Asc-Wert von T
Dim L as Byte 'Stringlnge

Dim I as Byte 'Laufvariable
Dim J as Byte 'Laufvariable
Dim Form(100) as Byte 'Helligkeitsverteilung whrend der Leuchtdauer  1 - 100
Dim Phase(20) as Word, EPhase(20) as ERAM Word'Dauer der Ein/Ausschaltphasen
Dim Anzahl as Byte, EAnzahl as ERAM Byte'Anzahl der Ein/Ausschaltphasen
'------------------------------------------------------------------------------
'Ausgabeport der pulsweitenmodulierten LED
Config PORTB.0 = Output
'Eingangsport zur Selektion des Programmiermodes
Config PinB.2 = Input
PortB.2 = 1 'Pullup- Widerstand ein
'ACHTUNG: PINB.2 ist auch SCK !!!!
'------------------------------------------------------------------------------
'               Timer0 - PWM
Config Timer0 = Pwm , Compare_A_Pwm = Clear_Up , Compare_B_Pwm = Clear_Up , Prescale = 1
Enable Timer0
'------------------------------------------------------------------------------
'               Timer1 - Zeitmessung und Ansteuerung des Leuchtfeuers
Preload1=131 'fr eine Zeitbasis von 0,001 Sekunde bei einem Prescale von 64
'Test 15 Sekunden: 14,95 Sekunden mit Preload1=131 und TCCR1= 7
TCCR1= 7   'Config Timer1 = Timer, Prescale = 64
on Timer1 Zeitbasis1
Enable Timer1
Enable Interrupts
'------------------------------------------------------------------------------
'Hauptprogramm
if PinB.2=0 then
'Programmiermode:
   Gosub UP_Erfassen

   'Auswahl der Kurvenform ins EEPROM schreiben:
   EKurvenform=Kurvenform

   'Anzahl der Ein/Ausschaltphasen ins EEPROM schreiben:
   EAnzahl=Anzahl

   'Lnge der Ein/Ausschaltphasen ins EEPROM schreiben:
   For I= 1 to Anzahl
      EPhase(I) = Phase(I)
   next I
else
'Werte aus dem EEPROM einlesen
   'Schlssel fr Kurvenform aus dem EEPROM einlesen:
   Kurvenform = EKurvenform

   'Anzahl der Ein-Ausschaltphasen aus dem EEPROM einlesen:
   Anzahl = EAnzahl

   'Lnge der Ein/Ausschaltphasen aus dem EEPROM einlesen:
   For I= 1 to Anzahl
      Phase(I) = EPhase(I)
   next I
end if

'Die Kurvenformen generieren:
Gosub UP_Kurvenform

'Der Leuchtturm arbeitet:
Do
   for I= 1 to Anzahl
      if Phase(I) >30000 then
         LEDAn=1
         MaxZeit = Phase(I) - 30000
      else
         LEDAn=0
         MaxZeit = Phase(I) 'Phase()*0,001 Sekunden
      end if
      'Die Dauer fr einen der 100 Helligkeitswerte errechnen:
      PWMEinheit=MaxZeit/100
      'Die Zeitroutine aktivieren:
      Zeitmessung_ein = 1
      do
         'Warten bis die Zeitroutine abgelaufen ist
      Loop until Zeitmessung_ein = 0
   next I
Loop
End
'------------------------------------------------------------------------------
UP_Kurvenform:
'Kurvenform der On-Phase festlegen
Select case Kurvenform
Case is = 2
   'Blitzfeuer / Drehlicht
   for I=1 to 50
      J=I/5
      Form(I)=J
   Next I
   For I = 51 To 100
      J = 101 - I
      Form(i) = Form(j)
   Next I
   For I= 45 to 55
      Form(I)=255
   next I
   Form(45) = 100
   Form(55) = 100
   break
Case is = 3
'Funkelfeuer
   for I=1 to 50
      J=I*5
      Form(I)=J
   Next I
   For I = 51 To 100
      J = 101 - I
      Form(i) = Form(j)
   Next I
   break
case else
   'On/Off
   For I= 1 to 100
      Form(I)=255
   next I
end select
Return
'------------------------------------------------------------------------------
UP_Erfassen:
Open "comb.4:9600,8,n,1" For Input As #1
Open "comb.3:9600,8,n,1" For Output As #2

print#2, chr(13)
Print#2, "EINSTELLUNGEN";chr(13);Chr(10);
Print #2, "Eingabe der Kennung des Seezeichens";chr(13);Chr(10);
Print #2, chr(13); chr(10);

do
   Print#2,"Kurvenform: 1 = ON/OFF, 2 = BLitzfeuer, 3 = Funkelfeuer: ";
   E="":Wl=1:gosub UP_Eingabe
   Kurvenform=val(E)
      if Kurvenform=0 then Kurvenform = 1
      if Kurvenform>3 then
         Print#2,"FEHLER! max 3"
         Print#2,chr(13);Chr(10);
      end if
loop Until Kurvenform < 4
Print#2,chr(13);Chr(10);

do
   Print#2,"Gesamte Anzahl der LED-An/Aus Phasen: ";
   E="":Wl=2:gosub UP_Eingabe
   Anzahl=val(E)
      if Anzahl=0 then Anzahl = 2
      if Anzahl>20 then
         Print#2,"FEHLER! max, 20"
         Print#2,chr(13);Chr(10);
      end if
loop Until Anzahl < 20
Print#2,chr(13);Chr(10);

do
   incr I
   do
      Print#2,I;". Phase: LED an = 1, aus = 0: ";
      E="":Wl=6:gosub UP_Eingabe
      LEDAn = val(E)
         if LEDAn>1 then
            Print#2,"FEHLER! nur 0 oder 1"
            Print#2,chr(13);Chr(10);
         end if
   loop Until LEDAn < 2
   do
      Print#2,"Dauer der ";I;". LED-An/Aus Phase in mS: ";
      E="":Wl=6:gosub UP_Eingabe
      Phase(I)=val(E)
         if Phase(I)=0 then Phase(I) = 1
         if Phase(I)>30000 then
            Print#2,"FEHLER! max, 30000"
            Print#2,chr(13);Chr(10);
         end if
   loop Until Phase(I) < 30001

   if LEDAn= 1 then
      Phase(i)=Phase(I)+30000
   end if

loop until I=>Anzahl
Print#2,chr(13);Chr(10);

Close #1
Close #2
Return
'------------------------------------------------------------------------------
UP_Eingabe:
do
   Gosub Hole_ein_Zeichen
   L = Len(E)
   A=Asc(T)
   Select Case A
      Case is = 8
      'Backspace
      if L >0 then
         Decr L
         E=Left(E,L)
         Print #2,T;
      End if
      Break

      Case is = 13
      'Return
      Break

      Case 48 to 57
      'Zahlen von 0 bis 9
         if L < Wl then
            E=E+T
         End if
         Print#2,T;
      Break

      Case Else
         !NOP
   End Select
loop until A=13

Print#2,chr(13);Chr(10);
Return
'------------------------------------------------------------------------------
Hole_ein_Zeichen:
Do
   T=inkey(#1)
Loop until T<>""
Return
'------------------------------------------------------------------------------
Zeitbasis1:
   Timer1 = Preload1
if Zeitmessung_ein=1 then
   incr Zeit
   incr N
   if Zeit <= MaxZeit then
      if N>PWMEinheit then
         N=0
         incr PWMZeit
         if LEDan = 1 then
            OCR0A = Form(PWMZeit)
         else
            OCR0A = 0
         end if
      end if
   else
      Zeitmessung_ein = 0
      Zeit = 0
      PWMZeit=0
      N=0
   end if
end if
Return
'------------------------------------------------------------------------------